/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author admin
 */
@Entity
@Table(name = "discreet_values")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "DiscreetValues.findAll", query = "SELECT d FROM DiscreetValues d"),
    @NamedQuery(name = "DiscreetValues.findByIdValue", query = "SELECT d FROM DiscreetValues d WHERE d.idValue = :idValue"),
    @NamedQuery(name = "DiscreetValues.findByDatum", query = "SELECT d FROM DiscreetValues d WHERE d.datum = :datum")})
public class DiscreetValues implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "disceet_seq")
    @SequenceGenerator(name = "disceet_seq", sequenceName = "discreet_values_id_value_seq", allocationSize = 1)
    @Basic(optional = false)
    @Column(name = "id_value")
    private Integer idValue;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 50)
    @Column(name = "datum")
    private String datum;
    @OneToMany(mappedBy = "valueid")
    private Collection<HasDiscreet> hasDiscreetCollection;
    @JoinColumn(name = "feature", referencedColumnName = "id_feature")
    @ManyToOne
    private Features feature;

    public DiscreetValues() {
    }

    public DiscreetValues(Integer idValue) {
        this.idValue = idValue;
    }

    public DiscreetValues(Integer idValue, String datum) {
        this.idValue = idValue;
        this.datum = datum;
    }

    public Integer getIdValue() {
        return idValue;
    }

    public void setIdValue(Integer idValue) {
        this.idValue = idValue;
    }

    public String getDatum() {
        return datum;
    }

    public void setDatum(String datum) {
        this.datum = datum;
    }

    @XmlTransient
    public Collection<HasDiscreet> getHasDiscreetCollection() {
        return hasDiscreetCollection;
    }

    public void setHasDiscreetCollection(Collection<HasDiscreet> hasDiscreetCollection) {
        this.hasDiscreetCollection = hasDiscreetCollection;
    }

    public Features getFeature() {
        return feature;
    }

    public void setFeature(Features feature) {
        this.feature = feature;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idValue != null ? idValue.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DiscreetValues)) {
            return false;
        }
        DiscreetValues other = (DiscreetValues) object;
        if ((this.idValue == null && other.idValue != null) || (this.idValue != null && !this.idValue.equals(other.idValue))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return datum;
    }
    
}
