/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;
import java.util.Locale;
import java.util.ResourceBundle;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author admin
 */
@Entity
@Table(name = "features")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Features.findAll", query = "SELECT f FROM Features f"),
    @NamedQuery(name = "Features.findByIdFeature", query = "SELECT f FROM Features f WHERE f.idFeature = :idFeature"),
    @NamedQuery(name = "Features.findByFeatureName", query = "SELECT f FROM Features f WHERE f.featureName = :featureName"),
    @NamedQuery(name = "Features.findByUnits", query = "SELECT f FROM Features f WHERE f.units = :units"),
    @NamedQuery(name = "Features.findByDescription", query = "SELECT f FROM Features f WHERE f.description = :description"),
    @NamedQuery(name = "Features.findByKindOfValue", query = "SELECT f FROM Features f WHERE f.kindOfValue = :kindOfValue")})
public class Features implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id_feature")
    private Integer idFeature;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 25)
    @Column(name = "feature_name")
    private String featureName;
    @Size(max = 20)
    @Column(name = "units")
    private String units;
    @Size(max = 2147483647)
    @Column(name = "description")
    private String description;
    @Column(name = "kind_of_value")
    private Short kindOfValue;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "features")
    private Collection<HasInt> hasIntCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "features")
    private Collection<HasDiscreet> hasDiscreetCollection;
    @OneToMany(mappedBy = "feature")
    private Collection<DiscreetValues> discreetValuesCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "features")
    private Collection<HasDecimal> hasDecimalCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "features")
    private Collection<HasString> hasStringCollection;

    public Features() {
    }

    public Features(Integer idFeature) {
        this.idFeature = idFeature;
    }

    public Features(Integer idFeature, String featureName) {
        this.idFeature = idFeature;
        this.featureName = featureName;
    }
    
    public int getMinInt() {
        Iterator<HasInt> it = hasIntCollection.iterator();
        int min = it.next().getDatum();
        int aux;
        while (it.hasNext()) {
            aux = it.next().getDatum();
            if(aux<min) {
                min = aux;
            }
        }
        return min;
    }
    
    public int getMaxInt() {
        Iterator<HasInt> it = hasIntCollection.iterator();
        int max = it.next().getDatum();
        int aux;
        while (it.hasNext()) {
            aux = it.next().getDatum();
            if(max<aux) {
                max = aux;
            }
        }
        return max;
    }
    
    public float getMinFloat() {
        Iterator<HasDecimal> it = hasDecimalCollection.iterator();
        float min = it.next().getDatum().floatValue();
        float aux;
        while (it.hasNext()) {
            aux = it.next().getDatum().floatValue();
            if(aux<min) {
                min = aux;
            }
        }
        return min;
    }
    
    public float getMaxFloat() {
        Iterator<HasDecimal> it = hasDecimalCollection.iterator();
        float max = it.next().getDatum().floatValue();
        float aux;
        while (it.hasNext()) {
            aux = it.next().getDatum().floatValue();
            if(max<aux) {
                max = aux;
            }
        }
        return max;
    }

    public Integer getIdFeature() {
        return idFeature;
    }

    public void setIdFeature(Integer idFeature) {
        this.idFeature = idFeature;
    }

    public String getFeatureName() {
        return featureName;
    }

    public void setFeatureName(String featureName) {
        this.featureName = featureName;
    }

    public String getUnits() {
        return units;
    }

    public void setUnits(String units) {
        this.units = units;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Short getKindOfValue() {
        return kindOfValue;
    }

    public void setKindOfValue(Short kindOfValue) {
        this.kindOfValue = kindOfValue;
    }
    
    public String getStringKindOfValue() {
        switch (kindOfValue) {
            case 0: return ResourceBundle.getBundle("/Bundle").getString("DiscreetFeature");
            case 1: return ResourceBundle.getBundle("/Bundle").getString("IntegerFeature");
            case 2: return ResourceBundle.getBundle("/Bundle").getString("StringFeature");
            case 3: return ResourceBundle.getBundle("/Bundle").getString("FloatFeature");
        }
        return null;
    }

    @XmlTransient
    public Collection<HasInt> getHasIntCollection() {
        return hasIntCollection;
    }

    public void setHasIntCollection(Collection<HasInt> hasIntCollection) {
        this.hasIntCollection = hasIntCollection;
    }

    @XmlTransient
    public Collection<HasDiscreet> getHasDiscreetCollection() {
        return hasDiscreetCollection;
    }

    public void setHasDiscreetCollection(Collection<HasDiscreet> hasDiscreetCollection) {
        this.hasDiscreetCollection = hasDiscreetCollection;
    }

    @XmlTransient
    public Collection<DiscreetValues> getDiscreetValuesCollection() {
        return discreetValuesCollection;
    }

    public void setDiscreetValuesCollection(Collection<DiscreetValues> discreetValuesCollection) {
        this.discreetValuesCollection = discreetValuesCollection;
    }

    @XmlTransient
    public Collection<HasDecimal> getHasDecimalCollection() {
        return hasDecimalCollection;
    }

    public void setHasDecimalCollection(Collection<HasDecimal> hasDecimalCollection) {
        this.hasDecimalCollection = hasDecimalCollection;
    }

    @XmlTransient
    public Collection<HasString> getHasStringCollection() {
        return hasStringCollection;
    }

    public void setHasStringCollection(Collection<HasString> hasStringCollection) {
        this.hasStringCollection = hasStringCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idFeature != null ? idFeature.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Features)) {
            return false;
        }
        Features other = (Features) object;
        if ((this.idFeature == null && other.idFeature != null) || (this.idFeature != null && !this.idFeature.equals(other.idFeature))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entity.Features[ idFeature=" + idFeature + " ]";
    }
    
}
