/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author admin
 */
@Entity
@Table(name = "has_decimal")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "HasDecimal.findAll", query = "SELECT h FROM HasDecimal h"),
    @NamedQuery(name = "HasDecimal.findByProduct", query = "SELECT h FROM HasDecimal h WHERE h.hasDecimalPK.product = :product"),
    @NamedQuery(name = "HasDecimal.findByFeature", query = "SELECT h FROM HasDecimal h WHERE h.hasDecimalPK.feature = :feature"),
    @NamedQuery(name = "HasDecimal.findByDatum", query = "SELECT h FROM HasDecimal h WHERE h.datum = :datum")})
public class HasDecimal implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected HasDecimalPK hasDecimalPK;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Basic(optional = false)
    @NotNull
    @Column(name = "datum")
    private BigDecimal datum;
    @JoinColumn(name = "product", referencedColumnName = "id_product", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Products products;
    @JoinColumn(name = "feature", referencedColumnName = "id_feature", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Features features;

    public HasDecimal() {
    }

    public HasDecimal(HasDecimalPK hasDecimalPK) {
        this.hasDecimalPK = hasDecimalPK;
    }

    public HasDecimal(HasDecimalPK hasDecimalPK, BigDecimal datum) {
        this.hasDecimalPK = hasDecimalPK;
        this.datum = datum;
    }

    public HasDecimal(int product, int feature) {
        this.hasDecimalPK = new HasDecimalPK(product, feature);
    }

    public HasDecimalPK getHasDecimalPK() {
        return hasDecimalPK;
    }

    public void setHasDecimalPK(HasDecimalPK hasDecimalPK) {
        this.hasDecimalPK = hasDecimalPK;
    }

    public BigDecimal getDatum() {
        return datum;
    }

    public void setDatum(BigDecimal datum) {
        this.datum = datum;
    }

    public Products getProducts() {
        return products;
    }

    public void setProducts(Products products) {
        this.products = products;
    }

    public Features getFeatures() {
        return features;
    }

    public void setFeatures(Features features) {
        this.features = features;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (hasDecimalPK != null ? hasDecimalPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof HasDecimal)) {
            return false;
        }
        HasDecimal other = (HasDecimal) object;
        if ((this.hasDecimalPK == null && other.hasDecimalPK != null) || (this.hasDecimalPK != null && !this.hasDecimalPK.equals(other.hasDecimalPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return datum.toString();
    }
    
}
