/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author admin
 */
@Entity
@Table(name = "has_discreet")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "HasDiscreet.findAll", query = "SELECT h FROM HasDiscreet h"),
    @NamedQuery(name = "HasDiscreet.findByProductid", query = "SELECT h FROM HasDiscreet h WHERE h.hasDiscreetPK.productid = :productid"),
    @NamedQuery(name = "HasDiscreet.findByFeatureid", query = "SELECT h FROM HasDiscreet h WHERE h.hasDiscreetPK.featureid = :featureid")})
public class HasDiscreet implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected HasDiscreetPK hasDiscreetPK;
    @JoinColumn(name = "productid", referencedColumnName = "id_product", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Products products;
    @JoinColumn(name = "featureid", referencedColumnName = "id_feature", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Features features;
    @JoinColumn(name = "valueid", referencedColumnName = "id_value")
    @ManyToOne
    private DiscreetValues valueid;

    public HasDiscreet() {
    }

    public HasDiscreet(HasDiscreetPK hasDiscreetPK) {
        this.hasDiscreetPK = hasDiscreetPK;
    }

    public HasDiscreet(int productid, int featureid) {
        this.hasDiscreetPK = new HasDiscreetPK(productid, featureid);
    }

    public HasDiscreetPK getHasDiscreetPK() {
        return hasDiscreetPK;
    }

    public void setHasDiscreetPK(HasDiscreetPK hasDiscreetPK) {
        this.hasDiscreetPK = hasDiscreetPK;
    }

    public Products getProducts() {
        return products;
    }

    public void setProducts(Products products) {
        this.products = products;
    }

    public Features getFeatures() {
        return features;
    }

    public void setFeatures(Features features) {
        this.features = features;
    }

    public DiscreetValues getValueid() {
        return valueid;
    }

    public void setValueid(DiscreetValues valueid) {
        this.valueid = valueid;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (hasDiscreetPK != null ? hasDiscreetPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof HasDiscreet)) {
            return false;
        }
        HasDiscreet other = (HasDiscreet) object;
        if ((this.hasDiscreetPK == null && other.hasDiscreetPK != null) || (this.hasDiscreetPK != null && !this.hasDiscreetPK.equals(other.hasDiscreetPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return valueid.toString();
    }
    
}
