/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author admin
 */
@Entity
@Table(name = "has_int")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "HasInt.findAll", query = "SELECT h FROM HasInt h"),
    @NamedQuery(name = "HasInt.findByProduct", query = "SELECT h FROM HasInt h WHERE h.hasIntPK.product = :product"),
    @NamedQuery(name = "HasInt.findByFeature", query = "SELECT h FROM HasInt h WHERE h.hasIntPK.feature = :feature"),
    @NamedQuery(name = "HasInt.findByDatum", query = "SELECT h FROM HasInt h WHERE h.datum = :datum")})
public class HasInt implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected HasIntPK hasIntPK;
    @Basic(optional = false)
    @NotNull
    @Column(name = "datum")
    private int datum;
    @JoinColumn(name = "product", referencedColumnName = "id_product", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Products products;
    @JoinColumn(name = "feature", referencedColumnName = "id_feature", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Features features;

    public HasInt() {
    }

    public HasInt(HasIntPK hasIntPK) {
        this.hasIntPK = hasIntPK;
    }

    public HasInt(HasIntPK hasIntPK, int datum) {
        this.hasIntPK = hasIntPK;
        this.datum = datum;
    }

    public HasInt(int product, int feature) {
        this.hasIntPK = new HasIntPK(product, feature);
    }

    public HasIntPK getHasIntPK() {
        return hasIntPK;
    }

    public void setHasIntPK(HasIntPK hasIntPK) {
        this.hasIntPK = hasIntPK;
    }

    public int getDatum() {
        return datum;
    }

    public void setDatum(int datum) {
        this.datum = datum;
    }

    public Products getProducts() {
        return products;
    }

    public void setProducts(Products products) {
        this.products = products;
    }

    public Features getFeatures() {
        return features;
    }

    public void setFeatures(Features features) {
        this.features = features;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (hasIntPK != null ? hasIntPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof HasInt)) {
            return false;
        }
        HasInt other = (HasInt) object;
        if ((this.hasIntPK == null && other.hasIntPK != null) || (this.hasIntPK != null && !this.hasIntPK.equals(other.hasIntPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return new Integer(datum).toString();
    }
    
}
