/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author admin
 */
@Entity
@Table(name = "has_string")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "HasString.findAll", query = "SELECT h FROM HasString h"),
    @NamedQuery(name = "HasString.findByProduct", query = "SELECT h FROM HasString h WHERE h.hasStringPK.product = :product"),
    @NamedQuery(name = "HasString.findByFeature", query = "SELECT h FROM HasString h WHERE h.hasStringPK.feature = :feature"),
    @NamedQuery(name = "HasString.findByDatum", query = "SELECT h FROM HasString h WHERE h.datum = :datum")})
public class HasString implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected HasStringPK hasStringPK;
    @Size(max = 50)
    @Column(name = "datum")
    private String datum;
    @JoinColumn(name = "product", referencedColumnName = "id_product", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Products products;
    @JoinColumn(name = "feature", referencedColumnName = "id_feature", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Features features;

    public HasString() {
    }

    public HasString(HasStringPK hasStringPK) {
        this.hasStringPK = hasStringPK;
    }

    public HasString(int product, int feature) {
        this.hasStringPK = new HasStringPK(product, feature);
    }

    public HasStringPK getHasStringPK() {
        return hasStringPK;
    }

    public void setHasStringPK(HasStringPK hasStringPK) {
        this.hasStringPK = hasStringPK;
    }

    public String getDatum() {
        return datum;
    }

    public void setDatum(String datum) {
        this.datum = datum;
    }

    public Products getProducts() {
        return products;
    }

    public void setProducts(Products products) {
        this.products = products;
    }

    public Features getFeatures() {
        return features;
    }

    public void setFeatures(Features features) {
        this.features = features;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (hasStringPK != null ? hasStringPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof HasString)) {
            return false;
        }
        HasString other = (HasString) object;
        if ((this.hasStringPK == null && other.hasStringPK != null) || (this.hasStringPK != null && !this.hasStringPK.equals(other.hasStringPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return new Float(datum).toString();
    }
    
}
