/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author admin
 */
@Entity
@Table(name = "products")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Products.findAll", query = "SELECT p FROM Products p"),
    @NamedQuery(name = "Products.findByIdProduct", query = "SELECT p FROM Products p WHERE p.idProduct = :idProduct"),
    @NamedQuery(name = "Products.findByProductName", query = "SELECT p FROM Products p WHERE p.productName = :productName"),
    @NamedQuery(name = "Products.findByPrice", query = "SELECT p FROM Products p WHERE p.price = :price"),
    @NamedQuery(name = "Products.findByDescription", query = "SELECT p FROM Products p WHERE p.description = :description"),
    @NamedQuery(name = "Products.findByImageUrl", query = "SELECT p FROM Products p WHERE p.imageUrl = :imageUrl"),
    @NamedQuery(name = "Products.findByQuantity", query = "SELECT p FROM Products p WHERE p.quantity = :quantity")})
public class Products implements Serializable {
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "products")
    private Collection<HasInt> hasIntCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "products")
    private Collection<HasDiscreet> hasDiscreetCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "products")
    private Collection<Contains> containsCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "products")
    private Collection<HasDecimal> hasDecimalCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "products")
    private Collection<HasString> hasStringCollection;
    @JoinColumn(name = "category", referencedColumnName = "category_name")
    @ManyToOne(optional = false)
    private Categories category;
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "product_seq")
    @SequenceGenerator(name = "product_seq", sequenceName = "products_id_product_seq", allocationSize = 1)
    @Column(name = "id_product")
    private Integer idProduct;
    @Basic(optional = false)
    @Size(min = 1, max = 30)
    @Column(name = "product_name")
    private String productName;
    @Column(name = "price")
    private BigDecimal price;
    @Size(max = 2147483647)
    @Column(name = "description")
    private String description;
    @Basic(optional = false)
    @Size(min = 1, max = 100)
    @Column(name = "image_url")
    private String imageUrl;
    @Column(name = "quantity")
    private Integer quantity;

    public Products() {
    }

    public Products(Integer idProduct) {
        this.idProduct = idProduct;
    }

    public Products(Integer idProduct, String productName, String imageUrl) {
        this.idProduct = idProduct;
        this.productName = productName;
        this.imageUrl = imageUrl;
    }

    public Integer getIdProduct() {
        return idProduct;
    }

    public void setIdProduct(Integer idProduct) {
        this.idProduct = idProduct;
    }

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getImageUrl() {
        return imageUrl;
    }

    public void setImageUrl(String imageUrl) {
        this.imageUrl = imageUrl;
    }

    public Integer getQuantity() {
        return quantity;
    }

    public void setQuantity(Integer quantity) {
        this.quantity = quantity;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idProduct != null ? idProduct.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Products)) {
            return false;
        }
        Products other = (Products) object;
        if ((this.idProduct == null && other.idProduct != null) || (this.idProduct != null && !this.idProduct.equals(other.idProduct))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entity.Products[ idProduct=" + idProduct + " ]";
    }

    public Categories getCategory() {
        return category;
    }

    public void setCategory(Categories category) {
        this.category = category;
    }

    @XmlTransient
    public Collection<HasInt> getHasIntCollection() {
        return hasIntCollection;
    }

    public void setHasIntCollection(Collection<HasInt> hasIntCollection) {
        this.hasIntCollection = hasIntCollection;
    }

    @XmlTransient
    public Collection<HasDiscreet> getHasDiscreetCollection() {
        return hasDiscreetCollection;
    }

    public void setHasDiscreetCollection(Collection<HasDiscreet> hasDiscreetCollection) {
        this.hasDiscreetCollection = hasDiscreetCollection;
    }

    @XmlTransient
    public Collection<Contains> getContainsCollection() {
        return containsCollection;
    }

    public void setContainsCollection(Collection<Contains> containsCollection) {
        this.containsCollection = containsCollection;
    }

    @XmlTransient
    public Collection<HasDecimal> getHasDecimalCollection() {
        return hasDecimalCollection;
    }

    public void setHasDecimalCollection(Collection<HasDecimal> hasDecimalCollection) {
        this.hasDecimalCollection = hasDecimalCollection;
    }

    @XmlTransient
    public Collection<HasString> getHasStringCollection() {
        return hasStringCollection;
    }

    public void setHasStringCollection(Collection<HasString> hasStringCollection) {
        this.hasStringCollection = hasStringCollection;
    }
    
    public boolean checkHasDecimal(Features f, float value) {
        Iterator<HasDecimal> it = hasDecimalCollection.iterator();
        HasDecimal h;
        boolean valid = false;
        
        while(it.hasNext()&&!valid) {
            h = it.next();
            if(h.getFeatures().equals(f)&&h.getDatum().floatValue()-value<0.5) {
                valid = true;
            }
        }
        return valid;
    }
    
    public boolean checkHasInt(Features f, int value) {
        Iterator<HasInt> it = hasIntCollection.iterator();
        HasInt h;
        boolean valid = false;
        
        while(it.hasNext()&&!valid) {
            h = it.next();
            if(h.getFeatures().equals(f)&&h.getDatum()-value < 2) {
                valid = true;
            }
        }
        return valid;
    }
    
    public boolean checkHasString(Features f, String value) {
        Iterator<HasString> it = hasStringCollection.iterator();
        HasString h;
        boolean valid = false;
        
        while(it.hasNext()&&!valid) {
            h = it.next();
            if(h.getFeatures().equals(f)) {
                if(areSimilar(value,h.getDatum())) {
                    valid = true;
                }
            }
        }
        return valid;
    }
    
    public boolean isDiscreet(Features f, String value) {
        Iterator<HasDiscreet> it = hasDiscreetCollection.iterator();
        HasDiscreet h;
        boolean valid = false;
        
        while(it.hasNext()&&!valid) {
            h = it.next();
            if(h.getFeatures().equals(f)&&h.getValueid().getDatum().equals(value)) {
                valid = true;
            }
        }
        return valid;
    }

    private boolean areSimilar(String value, String datum) {
        int i;
        for(i=0;i+5<value.length();i++) {
            if(datum.indexOf(value.substring(i, i+5))>-1) {
                return true;
            }
        }
        return false;
    }
}
