package faces;

import faces.util.JsfUtil;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import org.primefaces.event.FileUploadEvent;

/**
 * @author Lluís Gassó
 */
@ManagedBean(name = "fileUploadController")
@RequestScoped

public class FileUploadController {
   
    //Primitives
    private static final int BUFFER_SIZE = 6124;
    private static final String baseDirectory = 
            FacesContext
            .getCurrentInstance()
            .getExternalContext()
            .getRealPath("/")
            .split("/build")[0]+ "/web/resources/img/";
    private String imageURL;
    
    /** Returns the image URL */
    public String getImageURL() {
        return imageURL;
    }

    /** Creates a new instance of UploadBean */
    public void uploadFilesBean() {
    }
    
    public void handleFileUpload(FileUploadEvent event) {
            
            File result;
            result = new File(baseDirectory + event.getFile().getFileName());

            try {
                FileOutputStream fileOutputStream = new FileOutputStream(result);
                byte[] buffer = new byte[BUFFER_SIZE];
                int bulk;
                InputStream inputStream = event.getFile().getInputstream();
                while (true) {
                    bulk = inputStream.read(buffer);
                    if (bulk < 0) {
                        break;
                    }
                    fileOutputStream.write(buffer, 0, bulk);
                    fileOutputStream.flush();
                }

                fileOutputStream.close();
                inputStream.close();
                this.imageURL = event.getFile().getFileName();

            } catch (IOException e) {
                JsfUtil.addErrorMessage(e, e.getMessage());
            }
    }
    
    public List<String> getImages() {
        ArrayList<String> images;
        images = new ArrayList<String>();
        File imageDirectory = new File(baseDirectory);
        String[] imageNames = imageDirectory.list();
        int i;
        
        for(i=0;i<imageNames.length;i++) {
            images.add(imageNames[i]);
        }
        
        return images;
    }
}